#include <vector>
#include <algorithm>
#include <iostream>
#include <limits.h>
#include <utility>

using namespace std;

//const int SIZE = 5001;
//const int SQUARED = SIZE * SIZE;
int SIZE_X = 0;
int SIZE_Y = 0;


bool upgrade(int x, int y, int val, vector<int>& map) {
	if (x >= SIZE_X || y >= SIZE_Y || x < 0 || y < 0)
		return false;
		

	if (map[y * SIZE_X + x] > val) {
		map[y * SIZE_X + x] = val;
		return true;
	}


	return false;
}

int main() {
	int guardCount, incidentCount;
	cin >> guardCount;
	cin >> incidentCount;
	vector<pair<int, int>> guards(guardCount);
	vector<pair<int, int>> incidents(incidentCount);
	

	for (int i = 0; i < guardCount; i++) {
		int x, y;
		cin >> x;
		cin >> y;

		if (SIZE_X < x + 1)
			SIZE_X = x + 1;

		if (SIZE_Y < y + 1)
			SIZE_Y = y + 1;

		guards[i] = make_pair(x, y);
	}

	for (int i = 0; i < incidentCount; i++) {
		int x, y;
		cin >> x;
		cin >> y;

		if (SIZE_X < x + 1)
			SIZE_X = x + 1;

		if (SIZE_Y < y + 1)
			SIZE_Y = y + 1;

		incidents[i] = make_pair(x, y);
	}


		
	vector<int> map(SIZE_X * SIZE_Y, INT_MAX);

	for (int i = 0; i < guardCount; i++) {
		int x, y;
		x = guards[i].first;
		y = guards[i].second;


		bool upgraded;
		int dist = 0;
		do {
			upgraded = false;
			
			int tlX = x - dist;
			int tlY = y - dist;

			int trX = x + dist;
			int trY = tlY;

			int length = dist*2 + 1;

			for (int j = 0; j < length; j++) {
				int lX = tlX;
				int lY = tlY + j;

				int rX = trX;
				int rY = trY + j;

				upgraded = upgrade(lX, lY, dist, map) || upgraded;
				upgraded = upgrade(rX, rY, dist, map) || upgraded;
			}

			for (int j = 1; j < length - 1; j++) {
				int tX = tlX + j;
				int tY = tlY;

				int bX = tlX + j;
				int bY = tlY + length - 1;

				upgraded = upgrade(tX, tY, dist, map) || upgraded;
				upgraded = upgrade(bX, bY, dist, map) || upgraded;
			}

		dist++;
		} while (upgraded == true);
	}

	for (int i = 0; i < incidentCount; i++) {
		int x, y;
		x = incidents[i].first;
		y = incidents[i].second;

		cout << map[y * SIZE_X + x] << endl;
	}
				

	return 0;
}
